#ifndef _FlowInterpolation_h
#define _FlowInterpolation_h

#include "Matrix.h"
#include "Vector.h"
#include "Image.h"
#include <QList>

class FlowInterpolation
{
private:
	QList<Vector> xList;
	QList<Matrix> invCovList;
	QList<Vector> meanList;
	QList<double> weightList;
	int imWidth,imHeight;
	DImage interpFlow;
	DImage foobar1;
	int level;
public:
	FlowInterpolation(void);
	~FlowInterpolation(void);
	void Initialize(int width,int height);
	void Initialize(const DImage& flow);
	void setLevel(int n){level=n;};
	void Interpolate(const QList<Vector> XList,const QList<Matrix>& InvCovList,const QList<Vector>& MeanList,double lambda,int nIterations);
	void LinearSystem(DImage& output, const DImage& input,double lambda);
	const DImage& flow() const{return interpFlow;};
	void dispFlow();
	void dispAccuracy();
};


#endif