#ifndef _IntegerImage_h
#define _IntegerImage_h

#include "Image.h"
#include <QFile>

class IntegerImage
{
private:
	double m_Min,m_Max,m_Interval;
	int imWidth,imHeight,nPixels;
	unsigned short int* pData;
public:
	IntegerImage(void);
	IntegerImage(const IntegerImage& other);
	~IntegerImage(void);
	void copyData(const IntegerImage& other);
	void release();
	void allocate(int width,int height);
	void allocate(const IntegerImage& other);
	IntegerImage& operator=(const IntegerImage& other);

	void fromDoublePrecision(const DImage& v);
	void toDoublePrecision(DImage& v) const;
	void toFloatPrecision(FImage& v) const;

	double val(int x, int y);

	// function to access the members
	int width()const {return imWidth;};
	int height()const {return imHeight;};

	// functions for file IO
	bool writeIntegerImage(QFile& file) const;
	bool readIntegerImage(QFile& file);
};

#endif