#ifndef _MaskPyramid_h
#define _MaskPyramid_h

#include <QList>
#include "Image.h"
#include "BinaryImage.h"

//----------------------------------------------------------------------------
// a class of of mask pyramid
//----------------------------------------------------------------------------
class MaskPyramid
{
private:
	int m_nLevels;
	QList<DImage> m_MaskList;
public:
	MaskPyramid(void);
	~MaskPyramid(void);
	void GenerateMask(const BinaryImage& mask,int nLevels);
	int nLevels() const {return m_nLevels;};

	const DImage& mask(int level) const{return m_MaskList[level];};
	DImage& mask(int level) {return m_MaskList[level];};
};

#endif
