#include "Motion.h"

Motion::Motion(void)
{
}

Motion::Motion(const Motion& other)
{
	copyData(other);
}


Motion::~Motion(void)
{
}


void Motion::copyData(const Motion& other)
{
	m_FlowFieldList=other.m_FlowFieldList;
}

Motion& Motion::operator =(const Motion& other)
{
	copyData(other);
	return *this;
}

bool Motion::writeMotion(QFile& file) const
{
	int numFlowFields=m_FlowFieldList.size();
	file.write((char *)&numFlowFields,sizeof(int));
	for(int i=0;i<numFlowFields;i++)
		if(!m_FlowFieldList[i].writeFlowField(file))
			return false;
	return true;
}

bool Motion::readMotion(QFile &file)
{
	m_FlowFieldList.clear();

	int numFlowFields;
	file.read((char *)&numFlowFields,sizeof(int));
	if(numFlowFields<0 || numFlowFields>1000)
		return false;
	for(int i=0;i<numFlowFields;i++)
	{
		m_FlowFieldList.append(FlowField());
		if(!m_FlowFieldList[i].readFlowField(file))
			return false;
	}
	return true;
}