#include "MotionPara.h"

MotionPara::MotionPara(void)
{
	
}

MotionPara::~MotionPara(void)
{
}

void MotionPara::copyData(const MotionPara &other)
{
	m_FlowParaList=other.m_FlowParaList;
	m_AlgorithmPara=other.m_AlgorithmPara;
}

MotionPara& MotionPara::operator=(const MotionPara& other)
{
	copyData(other);
	return *this;
}

int MotionPara::numFlowPara() const
{
	int n=m_FlowParaList.size();
	return n;
}

void MotionPara::dispFlowPara() const
{
	for(int i=0;i<m_FlowParaList.size();i++)
		m_FlowParaList[i].display();
	printf("Ratio: %f\n",m_AlgorithmPara.ratio());
	printf("Minimum width: %d\n",m_AlgorithmPara.minWidth());
	printf("Number of iterations (or outer fixed point iterations): %d\n",m_AlgorithmPara.nIterations());
	printf("Number of IRLS iterations (or inner fixed point iterations): %d\n",m_AlgorithmPara.nIRLSIterations());
	printf("Number of Conjugate Gradient iterations: %d\n",m_AlgorithmPara.nCGIterations());
	printf("\n");
}

//---------------------------------------------------------------------------------------------
// functions for file IO
//---------------------------------------------------------------------------------------------
bool MotionPara::writeMotionPara(QFile &file) const
{
	int numFlowPara=m_FlowParaList.size();
	file.write((char *)&numFlowPara,sizeof(int));
	for(int i=0;i<numFlowPara;i++)
		if(!m_FlowParaList[i].writeOpticalFlowPara(file))
			return false;
	if(!m_AlgorithmPara.writeAlgorithmPara(file))
		return false;
	return true;
}

bool MotionPara::readMotionPara(QFile &file)
{
	m_FlowParaList.clear();
	int numFlowPara;
	file.read((char *)&numFlowPara,sizeof(int));
	if(numFlowPara<0 || numFlowPara>10000) // this is already a very slopy range for the number of flow parameters
		return false;
	for(int i=0;i<numFlowPara;i++)
	{
		m_FlowParaList.append(OpticalFlowPara());
		if(!m_FlowParaList[i].readOpticalFlowPara(file))
			return false;
	}
	if(!m_AlgorithmPara.readAlgorithmPara(file))
		return false;
	return true;
}