
#ifndef _VideoSequence_h
#define _VideoSequence_h

#include <QObject>
#include <QString>
#include <QList>
#include <QStringList>
#include <QImage>
#include <QFileInfo>

class VideoSequence: public QObject
{
	Q_OBJECT
protected:
	QString framePath;
	QStringList fileList;
	QList<QImage> frameList;
	QImage m_Image;
	int curFrameIndex;
	int numFrames;
	bool IsVideoLoaded;
	bool framesRead;
public:
	VideoSequence(void);
	VideoSequence(const VideoSequence& videoSequence);
	virtual void copyData(const VideoSequence& videoSequence);
	~VideoSequence(void);

	virtual bool loadFrame();
	void updateFrameControl();
	virtual void clear();
	virtual void Initialize(const QString& path,const QFileInfoList& filelist);
	int NumFrames() const {return numFrames;};
	int currFrame() const {return curFrameIndex;};
	bool readInFrames();
	
signals:
	void ImageChanged(const QImage& image);
	void FrameControlChanged(bool firstFrame,bool preFrame,bool nextFrame,bool lastFrame);
	void FrameIndexChanged(int frameIndex);
	void Update();
	void NumFramesChanged(int nFrames);

public slots:
	virtual void gotoFrame(int index);
	virtual void gotoFirstFrame();
	virtual void gotoPreFrame();
	virtual void gotoNextFrame();
	virtual void gotoLastFrame();
};

#endif